-- Upgrade script to 5.2 from 5.3.

-- Fix store procedures related to MSD
IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('INSERT_METADATA_ATTRIBUTE') AND  OBJECTPROPERTY(id, 'IsProcedure') = 1)
DROP PROC INSERT_METADATA_ATTRIBUTE
;
GO
;
CREATE PROCEDURE INSERT_METADATA_ATTRIBUTE(
 @p_id varchar(50),
 @p_MIN_OCCURS  int,
 @p_MAX_OCCURS  int,
 @p_IS_PRESENTATIONAL  Smallint,
 @p_PARENT  bigint,
 @p_CON_ID  bigint,
 @p_CL_ID  bigint,
 @p_RS_ID  bigint,
 @p_pk  bigint OUT)
AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	DECLARE @starttrancount int;
	SET @starttrancount = @@TRANCOUNT;
	BEGIN TRY
		IF @starttrancount = 0 
			BEGIN TRANSACTION

	EXEC INSERT_COMPONENT_COMMON @p_pk = @p_pk OUTPUT;
	INSERT INTO METADATA_ATTRIBUTE
           (MTD_ATTR_ID,ID,MIN_OCCURS,MAX_OCCURS,IS_PRESENTATIONAL,PARENT,CON_ID,CL_ID,RS_ID)
     VALUES
           (@p_pk,@p_id,@p_MIN_OCCURS,@p_MAX_OCCURS,@p_IS_PRESENTATIONAL,@p_PARENT,@p_CON_ID,@p_CL_ID,@p_RS_ID);

	 IF @starttrancount = 0 
	        COMMIT TRANSACTION

	END TRY
	BEGIN CATCH
		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();
		IF XACT_STATE() <> 0 AND @starttrancount = 0 
			ROLLBACK TRANSACTION
	   RAISERROR (@ErrorMessage, -- Message text.
				   @ErrorSeverity, -- Severity.
				   @ErrorState -- State.
				   );
	END CATCH
	
END
;
GO
;
IF EXISTS (SELECT * FROM dbo.SYSOBJECTS WHERE id = object_id('INSERT_TARGET_OBJECT') AND  OBJECTPROPERTY(id, 'IsProcedure') = 1)
DROP PROC INSERT_TARGET_OBJECT
;
GO
;
CREATE PROCEDURE INSERT_TARGET_OBJECT(
 @p_id varchar(50),
 @p_ITEM_SCHEME_ID bigint,
 @p_MDT_ID bigint,
 @p_TYPE varchar(50),
 @p_pk  bigint OUT)
AS
BEGIN
	SET NOCOUNT ON;
	SET XACT_ABORT ON;
	DECLARE @starttrancount int;
	SET @starttrancount = @@TRANCOUNT;
	BEGIN TRY
		IF @starttrancount = 0 
			BEGIN TRANSACTION

		EXEC INSERT_COMPONENT_COMMON @p_pk = @p_pk OUTPUT;
		insert into TARGET_OBJECT (TARGET_OBJ_ID,ID,ITEM_SCHEME_ID,MDT_ID,TYPE) VALUES (@p_pk,@p_id,@p_ITEM_SCHEME_ID,@p_MDT_ID,@p_TYPE);
	IF @starttrancount = 0 
	        COMMIT TRANSACTION

	END TRY
	BEGIN CATCH
		DECLARE @ErrorMessage NVARCHAR(4000);
		DECLARE @ErrorSeverity INT;
		DECLARE @ErrorState INT;

		SELECT 
			@ErrorMessage = ERROR_MESSAGE(),
			@ErrorSeverity = ERROR_SEVERITY(),
			@ErrorState = ERROR_STATE();
		IF XACT_STATE() <> 0 AND @starttrancount = 0 
			ROLLBACK TRANSACTION
	   RAISERROR (@ErrorMessage, -- Message text.
				   @ErrorSeverity, -- Severity.
				   @ErrorState -- State.
				   );
	END CATCH
END
;
GO
;

-- add on delete cascade in MSD related tables
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_METADATA_TARGET_TO_ITEM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE METADATA_TARGET DROP CONSTRAINT FK_METADATA_TARGET_TO_ITEM
;

ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_ITEM FOREIGN KEY(MDT_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_TARGET_OBJECT_To_CCOMMON') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE TARGET_OBJECT DROP CONSTRAINT FK_TARGET_OBJECT_To_CCOMMON
;

ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_CCOMMON FOREIGN KEY(TARGET_OBJ_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_TARGET_OBJECT_To_MDT') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE TARGET_OBJECT DROP CONSTRAINT FK_TARGET_OBJECT_To_MDT
;

ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_MDT FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_METADATA_TARGET_TO_MSD') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE METADATA_TARGET DROP CONSTRAINT FK_METADATA_TARGET_TO_MSD
;

ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_MSD_TO_ARTEFACT') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE METADATA_STRUCTURE_DEFINITION DROP CONSTRAINT FK_MSD_TO_ARTEFACT
;

ALTER TABLE METADATA_STRUCTURE_DEFINITION   ADD  CONSTRAINT FK_MSD_TO_ARTEFACT FOREIGN KEY(MSD_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REPORT_STRUCTURE_To_ITEM') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE DROP CONSTRAINT FK_REPORT_STRUCTURE_To_ITEM
;


ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_ITEM FOREIGN KEY(RS_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REPORT_STRUCTURE_To_MSD') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE DROP CONSTRAINT FK_REPORT_STRUCTURE_To_MSD
;

ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REPORT_STRUCTURE_META_TARGET_METADATA_TARGET') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP CONSTRAINT FK_REPORT_STRUCTURE_META_TARGET_METADATA_TARGET
;

-- add on delete cascade
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REP_STRUCT_META_TAR_MD_TAR') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP CONSTRAINT FK_REP_STRUCT_META_TAR_MD_TAR
;

ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRUCT_META_TAR_MD_TAR FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REPORT_STRUCTURE_META_TARGET_REPORT_STRUCTURE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP CONSTRAINT FK_REPORT_STRUCTURE_META_TARGET_REPORT_STRUCTURE
;

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_REP_STRU_META_TAR_REP_STRU') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP CONSTRAINT FK_REP_STRU_META_TAR_REP_STRU
;

-- not adding an on delete cascade because of SQL Server
ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRU_META_TAR_REP_STRU FOREIGN KEY(RS_ID)
REFERENCES REPORT_STRUCTURE (RS_ID)
;

-- sync name with Oracle 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_METADATA_ATTRIBUTE_COMPONENT_COMMON') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE METADATA_ATTRIBUTE DROP CONSTRAINT FK_METADATA_ATTRIBUTE_COMPONENT_COMMON
;
ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_COMP_COMMON FOREIGN KEY(MTD_ATTR_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('FK_METADATA_ATTRIBUTE_METADATA_ATTRIBUTE') AND OBJECTPROPERTY(id, 'IsForeignKey') = 1)
ALTER TABLE METADATA_ATTRIBUTE DROP CONSTRAINT FK_METADATA_ATTRIBUTE_METADATA_ATTRIBUTE
;
ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_MD_ATTR FOREIGN KEY(PARENT) REFERENCES METADATA_ATTRIBUTE (MTD_ATTR_ID)
;
-- add field for notifications
ALTER TABLE DATAFLOW ADD DATA_LAST_UPDATE datetime NULL
;
-- always last
update DB_VERSION SET VERSION = '5.3'
;

